import csv
import openai

# Replace 'YOUR_OPENAI_API_KEY' with your actual OpenAI API key
api_key = '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'
openai.api_key = api_key

# Determine the maximum token limit based on your API plan
MAX_TOKENS_LIMIT = 4096  # Adjust this value based on your plan
PROMPT_MAX_LENGTH = 50   # Set a shorter prompt length (adjust as needed)

def read_categories_from_csv(file_path, set_index, separator=","):
    categories = []

    with open(file_path, newline='') as csvfile:
        reader = csv.reader(csvfile)
        for row in reader:
            category = row[set_index].strip()  # Remove leading and trailing whitespaces
            # Split categories using the specified separator
            categories.extend(category.split(separator))

    return categories

def find_best_matching_category(categories_set1, categories_set2):
    results = {}

    for category_set1 in categories_set1:
        best_match = None
        best_confidence = 0

        for category_set2 in categories_set2:
            # Construct the prompt for comparison using OpenAI's text completions
            prompt = f"Match '{category_set1}' with: '{category_set2}'."

            # Limit the prompt length to fit within the token limit
            prompt = prompt[:PROMPT_MAX_LENGTH]

            # Calculate the remaining tokens for the completion
            remaining_tokens = MAX_TOKENS_LIMIT - len(prompt)

            # Call the OpenAI API to get the completion using GPT-3.5 Turbo engine
            response = openai.Completion.create(
                engine="text-davinci-003",  # Use GPT-3.5 Turbo engine
                prompt=prompt,
                max_tokens=remaining_tokens,
                stop=None,
                temperature=0.7,  # Set a low temperature for focused responses
            )

            # Get the generated text of the completion
            completion_text = response['choices'][0]['text']

            # Extract the best match from the completion text
            best_match = completion_text.split(":")[-1].strip()

        results[category_set1] = best_match

    return results

def write_results_to_csv(results, output_file):
    with open(output_file, mode='w', newline='') as csvfile:
        writer = csv.writer(csvfile)
        writer.writerow(['Category_Set1', 'Matched_Category_Set2'])
        for category_set1, matched_category in results.items():
            writer.writerow([category_set1, matched_category])

if __name__ == "__main__":
    # Example usage
    set1_file_path = '/Users/filip/Desktop/set1.csv'
    set2_file_path = '/Users/filip/Desktop/set2.csv'
    output_file_path = "matched_results.csv"

    categories_set1 = read_categories_from_csv(set1_file_path, set_index=0, separator=",")
    categories_set2 = read_categories_from_csv(set2_file_path, set_index=0, separator=",")

    matched_categories = find_best_matching_category(categories_set1, categories_set2)

    # Output the matched categories to the console and CSV file
    for category_set1, matched_category in matched_categories.items():
        print(f"Matched '{category_set1}' to: {matched_category}")

    # Write the matched categories to a CSV file
    write_results_to_csv(matched_categories, output_file_path)
